(* Copyright 2008  The Regents of the University of California. 

   Licensed under the Apache License, Version 2.0 (the "License"); you
   may not use this file except in compliance with the License.  You
   may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
   implied.  See the License for the specific language governing
   permissions and limitations under the License. 
*)

type valueType =
    Bool of bool
  | String of string
  | Int of int
  | Float of float
  | StringList of string list
  | IntList of int list
exception OptionNotFoundException of string

(* val optionsDatabase : (string, valueType) Hashtbl.t
val usageMsg : string
val sourceFiles : string list ref
val arg_spec : (string * Arg.spec * string) list *)
val safe_msg: string
val unsafe_msg: string
val abort_msg: string
val buildOptionsDatabase : unit -> unit
val dumpOptionsDatabase : unit -> unit
val getSourceFiles : unit -> string list
val isSet : string -> bool
(* val getValueOf : string -> valueType *)

val getValueOfString : string -> string
val setValueOfString : string -> string -> unit
val getValueOfInt : string -> int
val setValueOfInt : string -> int -> unit
val getValueOfBool : string -> bool
val setValueOfBool : string -> bool -> unit
val getValueOfStringList : string -> string list
val getValueOfIntList : string -> int list
val errorseed_table : (string, bool) Hashtbl.t
val set_errorseed : string list -> unit
val get_errorseed : unit -> string list
val is_errorseed : string -> bool
