
type t = { parent : int array; rank : int array }

let create n =
  { parent = Array.init n (fun i -> i);
    rank = Array.create n 0 
  }

let rec find uf i =
  let pi = uf.parent.(i) in
  if pi == i then
    i
  else begin
    let ci = find uf pi in
    uf.parent.(i) <- ci;
    ci
  end

let union ( { parent = p; rank = r } as uf) x y =
  let cx = find uf x in
  let cy = find uf y in
  if cx != cy then begin
    if r.(cx) > r.(cy) then
      p.(cy) <- cx
    else if r.(cx) < r.(cy) then
      p.(cx) <- cy
    else begin
      r.(cx) <- r.(cx) + 1; p.(cy) <- cx
    end
  end

let getsets uf = 
  let h = Hashtbl.create 13 in
  for i = 0 to (Array.length uf.parent) - 1 do
    let rep = find uf i in
    let l = try Hashtbl.find h rep with Not_found -> [] in
    let l' = i :: l in
    Hashtbl.replace h uf.parent.(i) l'
  done;
  let listofsets = ref [] in
  Hashtbl.iter (fun k d -> listofsets := d :: !listofsets  ) h;
  !listofsets 

