# $Id: Config.makefile 1788 2007-09-28 18:23:28Z jgrundy $
# Set configuration options for make.

# Copyright 2007 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License"); you
# may not use this file except in compliance with the License.  You
# may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
# implied.  See the License for the specific language governing
# permissions and limitations under the License.

##############################################################################
# Ocaml Tools

OCAMLLEX    := ocamllex -q
OCAMLYACC   := ocamlyacc
OCAMLDEP    := ocamldep.opt
OCAMLC      := ocamlc.opt
OCAMLOPT    := ocamlopt.opt
OCAMLMKTOP  := ocamlmktop
OCAMLDOC    := ocamldoc
CAMLP4O     := camlp4o
OCAMLDSORT  := ocamldsort

##############################################################################
# Directories

ROOTDIR     := $(PWD)
LOCALDIR    := $(ROOTDIR)/../local
SRCDIR      := $(ROOTDIR)/src
BINDIR      := $(ROOTDIR)/bin
LIBDIR      := $(ROOTDIR)/include
DOCDIR      := $(ROOTDIR)/doc
STDLIBDIR   := $(shell $(OCAMLC) -where)

##############################################################################
# Compilation Options

CAMLP4_OPTS      := pa_macro.cmo
OCAML_OPTS       := -w Ae -pp "$(CAMLP4O) $(CAMLP4_OPTS)" -I +camlp4
BYTE_OPTS        := 
NATIVE_OPTS      := 
DOC_OPTS         := -html -sort -hide-warnings -d $(DOCDIR)/out/ocamldoc_html
# Note: The -hide-warnings option was introduced in OCaml 3.10.0.

##############################################################################
# Libraries

STDLIBS     := $(wildcard $(STDLIBDIR)/*.mli)
BYTELIBS    := nums.cma 
OPTLIBS     := nums.cmxa

##############################################################################
# Name for Custom Toplevel

TOPLEVEL    := $(BINDIR)/dpt_toplevel 

##############################################################################
# Compilation Flags

ifdef FAST
	CAMLP4_OPTS += -DFAST -unsafe
	NATIVE_OPTS += -inline 15 -noassert 
endif

ifdef DEBUG
	NATIVE_OPTS += -g
	BYTE_OPTS   += -g
endif

ifdef PROFILE
	CAMLP4_OPTS += -unsafe
	NATIVE_OPTS += -p -noassert
endif

