(* $Id: array_util.mli 1788 2007-09-28 18:23:28Z jgrundy $ *)
(** Utility functions for arrays. *)

(* Copyright 2007 Intel Corporation 

   Licensed under the Apache License, Version 2.0 (the "License"); you
   may not use this file except in compliance with the License.  You
   may obtain a copy of the License at
   
   http://www.apache.org/licenses/LICENSE-2.0
   
   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
   implied.  See the License for the specific language governing
   permissions and limitations under the License. *)

(** {2 Scanning} *)

val mem: 'a -> 'a array -> bool
  (** [mem x a] is true when [x] is an element of [a] *)

val exists: ('a -> bool) -> 'a array -> bool
  (** [exists p a i j] is true when there is some [x] in [a] [p x]. *)

val exists_const: ('a -> 'b -> bool) -> 'a -> 'b array -> bool
  (** [exists_const p x a] is the same as {!Array_util.exists}[ (p x)
      a], only faster because applying closures is slow. *)

val for_all: ('a -> bool) -> 'a array -> bool
  (** [for_all p a] is true when for every [x] in [a] [p x]. *)

val for_all_const: ('a -> 'b -> bool) -> 'a -> 'b array -> bool
  (** [for_all_const p x a] is the same as {!Array_util.for_all}[ (p
      x) a], only faster because applying closures is slow. *)
