(* $Id: function.ml 1788 2007-09-28 18:23:28Z jgrundy $ *)
(* Common functions and combinators. *)

(* Copyright 2007 Intel Corporation 

   Licensed under the Apache License, Version 2.0 (the "License"); you
   may not use this file except in compliance with the License.  You
   may obtain a copy of the License at
   
   http://www.apache.org/licenses/LICENSE-2.0
   
   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
   implied.  See the License for the specific language governing
   permissions and limitations under the License. *)

let id x = x
let const x _ = x
let compose f g x = f (g x)
let flip f x y = f y x
let curry f x y = f (x,y)
let uncurry f (x,y) = f x y
let rec until p f x = if p x then x else until p f (f x)
let rec fix r x = r (fix r) x
