(* $Id: dpll.mli 1793 2007-09-28 19:12:36Z jgrundy $ *)
(** A term-level DPLL solver. *)

(* Copyright 2007 Intel Corporation 

   Licensed under the Apache License, Version 2.0 (the "License"); you
   may not use this file except in compliance with the License.  You
   may obtain a copy of the License at
   
   http://www.apache.org/licenses/LICENSE-2.0
   
   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
   implied.  See the License for the specific language governing
   permissions and limitations under the License. *)

(** A term level interface to a DPLL solver.  The implementation uses
    a form of multi-input and-inverter graphs internally as a
    semi-canonical term representation.  More information about
    and-inverter graph schemes can be found in the following papers:

    - Andreas Kuehlmann, Viresh Paruthi, Florian Krohm, Malay
    K. Ganai.  {{:http://dx.doi.org/10.1109/TCAD.2002.804386} Robust
    Boolean reasoning for equivalence checking and functional property
    verification}. {i IEEE Transactions on Computer-Aided Design of
    Integrated Circuits and Systems} 21(12):1377-1394, 2002.
    - Per Bjesse, Arne Boralv.
    {{:http://dx.doi.org/10.1109/ICCAD.2004.1382541} DAG-aware circuit
    compression for formal verification}.  {i Computer Aided Design:
    Proceedings of the IEEE/ACM International Conference}, pp 42-49,
    2004. *)

class make: unit -> Solver_api.dpll
