module M = Message

open Ast
module P = Ast.Predicate
module E = Ast.Expression
module PT = PredTable 
module TP = Abs_config.TP

let new_var = ref 0
let get_new_var () = 
  let rv = !new_var in
	incr new_var;
	E.Symbol ("__b"^(string_of_int rv))
let reset_new_var () = new_var := 0

(*
let minimize p pvvals = pvvals
let rec get_allsat p varmap sofar =
  TP.block_reset ();
  TP.block_assert p;
  if TP.is_contra () then sofar 
  else begin
    let m = TP.get_model () in
    let vvals = List.map (fun (v,_) -> (v, Hashtbl.find m v) ) varmap in
    let pvvals = List.map 
	  (fun (v, vl) -> 
             if vl = Constant.Int 1 then P.Atom (E.Lval v) else P.Not (P.Atom(E.Lval v))) 
		vvals in
    let pvvals = minimize p pvvals in
    get_allsat (P.And [p; P.Not (P.And pvvals)]) varmap (pvvals :: sofar)
  end 
 *)
 
let allsat (p : P.predicate) (plist : (P.predicate * P.predicate) list) =
  M.msg_string M.Normal (Printf.sprintf "[ALLSAT] : p = %s " (P.toString p));
  M.msg_string M.Normal "[ALLSAT] List of predicates: " ;
  List.iter (fun (p1, p2) -> M.msg_string M.Normal (Printf.sprintf "[ALLSAT] p = %s wp = %s " (P.toString p2) (P.toString p1))) plist;
  let lookup l varmap = List.find (fun (v,p) -> v = l) varmap in
  let mk_and plist varmap =
    let subs = List.map (fun p ->  
      match p with 
        P.Atom (E.Lval v) -> let p' = snd (lookup v varmap) in p'
      | P.Not (P.Atom (E.Lval v)) -> let p' = snd (lookup v varmap) in P.Not p'
      | _ -> assert false
      ) plist in
    P.And subs
  in
  reset_new_var();
(*
  let varmap = List.map (fun p -> (get_new_var(), p)) plist in
  let pformula = 
    P.And (List.map (fun (v,p) -> P.Iff (P.Atom (E.Lval v), p)) varmap)
  in
*)
  let absp = TP.get_allsat p (List.map fst plist) in 
  let absp_t = P.deep_transform (fun p -> try let p' = List.assoc p plist in p' with _ -> p) absp in
  let absp_t = PT.convertBddToPred (PT.convertPredToBdd absp_t) in
  M.msg_string M.Normal (P.toString absp_t) 
