(* $Id: ternary.ml,v 1.1.1.1 2008/05/22 16:46:07 rupak Exp $ *)
(* Three valued booleans. *)

(* Copyright 2007 Intel Corporation 

   Licensed under the Apache License, Version 2.0 (the "License"); you
   may not use this file except in compliance with the License.  You
   may obtain a copy of the License at
   
   http://www.apache.org/licenses/LICENSE-2.0
   
   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
   implied.  See the License for the specific language governing
   permissions and limitations under the License. *)

type ternary = int

let truth = 1

let unknown = 0

let falsity = -1 

let valid t = (t = truth) || (t = falsity) || (t = unknown)

let ternary_of_bool b = if b then truth else falsity

let bool_of_ternary t =
  assert (valid t);
  assert (t != unknown);
  if t = truth then true else false

let negation x = 
  assert (valid x);
  -x

let conjunction x y = 
  assert (valid x && valid y);
  min x y

let disjunction x y = 
  assert (valid x && valid y);
  max x y
