(* $Id: time.mli,v 1.1.1.1 2008/05/22 16:46:07 rupak Exp $ *)
(** Elapsed user processor time points. *)

(* Copyright 2007 Intel Corporation 

   Licensed under the Apache License, Version 2.0 (the "License"); you
   may not use this file except in compliance with the License.  You
   may obtain a copy of the License at
   
   http://www.apache.org/licenses/LICENSE-2.0
   
   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
   implied.  See the License for the specific language governing
   permissions and limitations under the License. *)

(** Time point. *)
type time

val epoch: time
  (** Dawn of processor time. *)

val now: unit -> time
  (** Current processor time. *)

val since: time -> float
  (** [since t ()] is user processor time, in seconds, elapsed since
      [t]. *)
