#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/alloc.h>
#include <caml/custom.h>
#include "yicesl_c.h"

#define Context_val(v) (* ((yicesl_context **) Data_custom_val(v)))

static value alloc_context(yicesl_context * c) {
    value v = caml_alloc(sizeof(yicesl_context *), 0);
    Context_val(v) = c;
    return v;
}

value ml_yicesl_mk_context(value unit) {
    CAMLparam1(unit);
    CAMLreturn( alloc_context(yicesl_mk_context()) );
}

value ml_yicesl_del_context(value ctx) {
    CAMLparam1(ctx);
    yicesl_del_context(Context_val(ctx));
    CAMLreturn( Val_unit );
}

value ml_yicesl_read(value ctx, value cmd) {
    CAMLparam2(ctx, cmd);
    CAMLreturn(Val_int( yicesl_read(Context_val(ctx), String_val(cmd)) ));
}

value ml_yicesl_inconsistent(value ctx) {
    CAMLparam1(ctx);
    CAMLreturn(Val_int( yicesl_inconsistent(Context_val(ctx)) ));
}
