module Y = YicesInterfaceExt
module S = SimplifyInterface

open Misc
open Printf

let compare a b place = 
    if a <> b then
        failwith (sprintf "Yices and Simplify differ on %s" place);
    a

let block_reset () = 
    Y.block_reset ();
    S.block_reset ()

and block_assert pred = 
    Y.block_assert pred;
    S.block_assert pred

and block_check_unsat pred = 
    compare 
        (Y.block_check_unsat pred) 
        (S.block_check_unsat pred)
        "block_check_unsat"

and is_contra () =
    compare 
        (Y.is_contra ()) 
        (S.is_contra ())
        "is_contra"

and block_pop () = 
    Y.block_pop ();
    S.block_pop ()

and reset () = 
    Y.reset ();
    S.reset ()

and queryExp expr =
    compare (Y.queryExp expr) (S.queryExp expr) "queryExp"

and queryExpContext pred query = 
    compare 
        (Y.queryExpContext pred query) 
        (S.queryExpContext pred query)
        "queryExpContext"

and print_stats () = 
    Y.print_stats ();
    S.print_stats ()

and sat pred = 
    compare (Y.sat pred) (S.sat pred) "sat"

let get_allsat p plist = failwith "Yices: allsat: To do"
let whoami () = 
  Message.msg_string Message.Normal "Yices. Copyright SRI." ; "Yices (vs Simplify)"

