module Y = YicesInterface
module Yl = YicesLiteInterface
module Ye = YicesInterfaceExt

open Misc
open Printf

let compare a b place = 
    if a <> b then
        failwith (sprintf "Yices and YicesExt differ on %s" place);
    a

let block_reset () = 
    Yl.block_reset ();
    Ye.block_reset ()

and block_assert pred = 
    Yl.block_assert pred;
    Ye.block_assert pred

and block_check_unsat pred = 
    compare 
        (Yl.block_check_unsat pred) 
        (Ye.block_check_unsat pred)
        "block_check_unsat"

and is_contra () =
    compare 
        (Yl.is_contra ()) 
        (Ye.is_contra ())
        "is_contra"

and block_pop () = 
    Yl.block_pop ();
    Ye.block_pop ()

and reset () = 
    Yl.reset ();
    Ye.reset ()

and queryExp expr =
    compare (Yl.queryExp expr) (Ye.queryExp expr) "queryExp"

and queryExpContext pred query = 
    compare 
        (Yl.queryExpContext pred query) 
        (Ye.queryExpContext pred query)
        "queryExpContext"

and print_stats () = 
    Yl.print_stats ();
    Ye.print_stats ()

and sat pred = 
    compare (Yl.sat pred) (Ye.sat pred) "sat"
let get_allsat p plist = failwith "Yices: allsat: To do"
let whoami () = 
  Message.msg_string Message.Normal "Yices. Copyright SRI." ; "YicesVsYicesExt"

