type token =
  | Id of (string)
  | Const of (string)
  | Num of (int)
  | GLOBAL
  | LOCAL
  | ENV
  | STORE
  | PROC
  | PREDICATES
  | ANNOTATIONS
  | SEMICOLON
  | COLON
  | EOF
  | LPAREN
  | RPAREN
  | LINDEX
  | RINDEX
  | QUESTION
  | DOT
  | ARROW
  | BITAND
  | BITOR
  | DIV
  | LSHIFT
  | MINUS
  | MUL
  | PLUS
  | REM
  | RSHIFT
  | XOR
  | EQ
  | GE
  | GT
  | LE
  | LT
  | NE
  | INDEX
  | AND
  | OR
  | IMPLIES
  | FORALL
  | EXISTS
  | COMMA
  | NOT
  | BITNOT
  | DEREF
  | ADDRESS
  | SYMBOL
  | UMINUS
  | UPLUS
  | DOTSTAR
  | ARROWSTAR
  | ICR
  | DECR
  | SIZEOF
  | ASSIGN
  | MULTassign
  | DIVassign
  | MODassign
  | PLUSassign
  | MINUSassign
  | LSassign
  | RSassign
  | ANDassign
  | XORassign
  | ORassign
  | INT
  | CHAR
  | FLOAT
  | DOUBLE
  | LONG
  | VOID
  | CONSTANT

val fun_main :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> ((string * Ast.Predicate.predicate list) list)
val main :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> (Ast.Predicate.predicate list)
val env_assumptions :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> ((Ast.Expression.lval * (Ast.Predicate.predicate)) list)
val lval_list :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> (Ast.Expression.lval list)
val modifies_info :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> ((int * (Ast.Expression.lval list)) list ) * ((string * (Ast.Expression.lval list)) list) * ((Ast.Expression.lval * (string list)) list) * (( (int * int * int * int) * Ast.Expression.lval ) list)
